X_train=pd.DataFrame(X_train)
X_train.columns=feature_names

# GBM
gb = GradientBoostingClassifier(n_estimators=100, learning_rate=1.0,max_depth=1, random_state=42)
gb.fit(X_train, y_train)

# Scores
scores = cross_validate(gb, X_train, y_train, cv=7, scoring=scoring)

plt.figure(1)
#sel = SelectFromModel(RandomForestClassifier(n_estimators = 100,random_state=42))
sel = SelectFromModel(gb)
sel.fit(X_train, y_train)
sel.get_support()
selected_feat= X.columns[(sel.get_support())]
len(selected_feat)
print(selected_feat)
sorted_idx = gb.feature_importances_.argsort()
plt.barh(X.columns[sorted_idx], gb.feature_importances_[sorted_idx])
plt.xlabel("GBM Feature Importance")

feat_imp=['age', 'city', 'duration of asbestos exposure', 'keep side',
       'duration of symptoms', 'habit of cigarette', 'white blood',
       'cell count (WBC)', 'hemoglobin (HGB)', 'platelet count (PLT)',
       'blood lactic dehydrogenise (LDH)', 'alkaline phosphatise (ALP)',
       'albumin', 'pleural albumin', 'pleural glucose']

X=X[feat_imp]

# Light GBM
lgb = LGBMClassifier(random_state=42).fit(X_train,y_train)
lgb.fit(X_train,y_train)

plot_importance(lgb, importance_type='gain')

feat_imp = ['city', 'age','cell count (WBC)', 'duration of asbestos exposure', 'hemoglobin (HGB)', 'gender', 'glucose',
            'sedimentation', 'duration of symptoms', 'alkaline phosphatise (ALP)', 'blood lactic dehydrogenise (LDH)',
            'albumin', 'platelet count (PLT)']
X=X[feat_imp]

# Scores
print("--- %s seconds ---" % (time.time() - start_time))
scores = cross_validate(lgb, X_train, y_train, cv=7, scoring=scoring)

plt.figure(1)
#sel = SelectFromModel(RandomForestClassifier(n_estimators = 100,random_state=42))
sel = SelectFromModel(lgb)
sel.fit(X_train, y_train)
sel.get_support()
selected_feat= X.columns[(sel.get_support())]
len(selected_feat)
print(selected_feat)
sorted_idx = lgb.feature_importances_.argsort()
plt.barh(X.columns[sorted_idx], lgb.feature_importances_[sorted_idx])
plt.xlabel("Light GBM Feature Importance")

feat_imp=['age', 'gender', 'city', 'duration of asbestos exposure', 'keep side',
       'duration of symptoms', 'cell count (WBC)', 'platelet count (PLT)',
       'sedimentation', 'blood lactic dehydrogenise (LDH)',
       'alkaline phosphatise (ALP)', 'total protein', 'albumin', 'glucose',
       'pleural lactic dehydrogenise', 'pleural albumin', 'pleural glucose',
       'C-reactive protein (CRP)']

X=X[feat_imp]

# XGB
xgb = XGBClassifier(random_state=42)
xgb.fit(X_train, y_train)

plot_importance(xgb, importance_type='gain')
plt.show()

feat_imp = ['keep side', 'city', 'hemoglobin (HGB)', 'ache on chest', 'pleural lactic dehydrogenise',
           'age', 'duration of asbestos exposure', 'gender','habit of cigarette', 'glucose', 'cell count (WBC)',
           'duration of symptoms', 'pleural thickness on tomography', 'alkaline phosphatise (ALP)', 'weakness']
X=X[feat_imp]

# Scores
start_time = time.time()
scores = cross_validate(xgb, X_train, y_train, cv=7, scoring=scoring)
print("--- %s seconds ---" % ((time.time() - start_time)/7))


plt.figure(1)
#sel = SelectFromModel(RandomForestClassifier(n_estimators = 100,random_state=42))
sel = SelectFromModel(xgb)
sel.fit(X_train, y_train)
sel.get_support()
selected_feat= X.columns[(sel.get_support())]
len(selected_feat)
print(selected_feat)
sorted_idx = xgb.feature_importances_.argsort()
plt.barh(X.columns[sorted_idx], xgb.feature_importances_[sorted_idx])
plt.xlabel("XGB Feature Importance")

feat_imp=['age', 'city', 'duration of asbestos exposure', 'keep side',
       'duration of symptoms', 'cell count (WBC)',
       'alkaline phosphatise (ALP)', 'pleural lactic dehydrogenise']
X=X[feat_imp]




