# Odds ratio and standard model with no penalties
model=LogisticRegression(random_state=42, class_weight='balanced')
model.fit(X_train,y_train)

res = sm.Logit(y_train, X_train).fit()
res.summary()
np.exp(res.params)

# Scores
start_time = time.time()
scores = cross_validate(model, X_train, y_train, cv=7, scoring=scoring)
print("--- %s seconds ---" % ((time.time() - start_time)/7))

# LR l1
model=LogisticRegression(random_state=42, class_weight='balanced',penalty='l1',solver='liblinear')
model.fit(X_train,y_train)

# Scores
start_time = time.time()
scores = cross_validate(model, X_train, y_train, cv=7, scoring=scoring)
print("--- %s seconds ---" % ((time.time() - start_time)/7))

# Summary
# clf=Lasso(alpha=0.01)
# clf.fit(X_train, y_train)
# print(np.exp(clf.coef_))

# LR l2
model=LogisticRegression(random_state=42, class_weight='balanced',penalty='l2',solver='liblinear')
model.fit(X_train,y_train)

# Scores
start_time = time.time()
scores = cross_validate(model, X_train, y_train, cv=7, scoring=scoring)
print("--- %s seconds ---" % ((time.time() - start_time)/7))

# LR Elastic Net
model=LogisticRegression(random_state=42, class_weight='balanced', solver='saga', l1_ratio=0.5,
                         penalty='elasticnet')
model.fit(X_train,y_train)

# Scores
start_time = time.time()
scores = cross_validate(model, X_train, y_train, cv=7, scoring=scoring)
print("--- %s seconds ---" % ((time.time() - start_time)/7))

