mesdata = pd.read_excel(r'C:\Users\tedch\Documents\Thesis\Code\mesdata.xls')
mesdata = mesdata.rename(columns={'class of diagnosis': 'diagnosis'})
mesdata.diagnosis.replace({1:0,2:1},inplace=True)
y=mesdata.diagnosis
X=mesdata.drop(['diagnosis'],axis=1)
transform=['duration of symptoms', 'platelet count (PLT)', 'alkaline phosphatise (ALP)', 'glucose',
           'pleural lactic dehydrogenise', 'cell count (WBC)', 'blood lactic dehydrogenise (LDH)']
X[transform]=X[transform].apply(np.log)
X=mesdata.drop(['diagnosis', 'diagnosis method', 'pleural protein', 'type of MM', 'dead or not'],axis=1)
num_feat=['age','duration of asbestos exposure', 'duration of symptoms', 'white blood', 'cell count (WBC)',
          'platelet count (PLT)', 'sedimentation', 'blood lactic dehydrogenise (LDH)', 'alkaline phosphatise (ALP)',
          'total protein', 'albumin', 'glucose', 'pleural lactic dehydrogenise', 'pleural albumin',
          'pleural glucose', 'C-reactive protein (CRP)']

X_num = X[num_feat]
X_cat = X.drop(num_feat, axis=1)

# Gaussian
X_train,X_test,y_train,y_test= train_test_split(X_num,y, shuffle=True, test_size=0.2, random_state=42)
sc=StandardScaler()
X_train=sc.fit_transform(X_train)
X_test=sc.transform(X_test)
oversample = SMOTE(sampling_strategy='minority', random_state=42)
X_train, y_train= oversample.fit_resample(X_train, y_train)

gnb = GaussianNB()
gnb.fit(X_train, y_train)

# Scores
start_time = time.time()
scores = cross_validate(gnb, X_train, y_train, cv=7, scoring=scoring)
print("--- %s seconds ---" % ((time.time() - start_time)/7))

# Multinomial
mesdata = pd.read_excel(r'C:/Users/tedch/Documents/Thesis/mesdata.xlsx')
mesdata = mesdata.rename(columns={'class of diagnosis': 'diagnosis'})
mesdata.diagnosis.replace({1:0,2:1},inplace=True)
y=mesdata.diagnosis
X=mesdata.drop(['diagnosis', 'diagnosis method', 'pleural protein'],axis=1)
transform=['duration of symptoms', 'platelet count (PLT)', 'alkaline phosphatise (ALP)', 'glucose',
           'pleural lactic dehydrogenise', 'cell count (WBC)', 'blood lactic dehydrogenise (LDH)']
X[transform]=X[transform].apply(np.log)
num_feat=['age','duration of asbestos exposure', 'duration of symptoms', 'white blood', 'cell count (WBC)',
          'platelet count (PLT)', 'sedimentation', 'blood lactic dehydrogenise (LDH)', 'alkaline phosphatise (ALP)',
          'total protein', 'albumin', 'glucose', 'pleural lactic dehydrogenise', 'pleural albumin',
          'pleural glucose', 'C-reactive protein (CRP)']

X_num = X[num_feat]
X_cat = X.drop(num_feat, axis=1)
X_train,X_test,y_train,y_test= train_test_split(X_cat,y,test_size=0.2, random_state=42)
oversample = SMOTE(sampling_strategy='minority', random_state=42)
X_train, y_train= oversample.fit_resample(X_train, y_train)

mnb = MultinomialNB()
mnb.fit(X_train, y_train)

# Scores
start_time = time.time()
scores = cross_validate(mnb, X_train, y_train, cv=7, scoring=scoring)
print("--- %s seconds ---" % ((time.time() - start_time)/7))

# ComplementNB
cnb = ComplementNB()
cnb.fit(X_train, y_train)

# Scores
scores = cross_validate(cnb, X_train, y_train, cv=7, scoring=scoring)

# Mixed
X_train,X_test,y_train,y_test= train_test_split(X,y, shuffle=True, test_size=0.2, random_state=42)
oversample = SMOTE(sampling_strategy='minority', random_state=42)
X_train, y_train= oversample.fit_resample(X_train, y_train)

minb = MixedNB()
minb.fit(X_train, y_train)

# Scores
start_time = time.time()
scores = cross_validate(minb, X_train, y_train, cv=7, scoring=scoring)
print("--- %s seconds ---" % ((time.time() - start_time)/7))