rf = RandomForestClassifier(random_state=42, oob_score=True)
rf.fit(X_train, y_train,)

# Scores
start_time = time.time()
scores = cross_validate(rf, X_train, y_train, cv=7, scoring=scoring)
print("--- %s seconds ---" % ((time.time() - start_time)/7))

# Feature Importance
plt.figure(1)
#sel = SelectFromModel(RandomForestClassifier(n_estimators = 100,random_state=42))
sel = SelectFromModel(rf, threshold=0.035)
sel.fit(X_train, y_train)
sel.get_support()
selected_feat= X.columns[(sel.get_support())]
len(selected_feat)
print(selected_feat)
sorted_idx = rf.feature_importances_.argsort()
plt.barh(X.columns[sorted_idx], rf.feature_importances_[sorted_idx])
plt.xlabel("Random Forest Feature Importance")
# rf_feature_import = pd.Series(rf.estimators_,feature_importances_)

# Chi2 K Best
select_feature = SelectKBest(chi2, k=5).fit(X_train, y_train)
print('Score list:', select_feature.scores_)
print('Feature list:', X_train.columns)

# RFE
clf_rf_3 = RandomForestClassifier(n_estimators = 100,random_state=42)
rfe = RFE(estimator=clf_rf_3, n_features_to_select=5, step=1)
rfe = rfe.fit(X_train, y_train)
print('Chosen best 5 feature by rfe:',X_train.columns[rfe.support_])

# RFECV
clf_rf_4 = RandomForestClassifier(n_estimators = 100,random_state=42)
rfecv = RFECV(estimator=clf_rf_4, step=1, cv=7,scoring='accuracy')   #10-fold cross-validation
rfecv = rfecv.fit(X_train, y_train)
print('Chosen best 5 feature by rfe:',X_train.columns[rfecv.support_])

# Permutation
plt.figure(2)
perm_importance = permutation_importance(rf, X_test, y_test)
sorted_idx = perm_importance.importances_mean.argsort()
plt.barh(X_test.columns[sorted_idx], perm_importance.importances_mean[sorted_idx])
plt.xlabel("Permutation Importance")

# SHAP
explainer = shap.TreeExplainer(rf)
shap_values = explainer.shap_values(X_test)
shap.summary_plot(shap_values, X_test, plot_type="bar")
shap.summary_plot(shap_values, X_test)
print("--- %s seconds ---" % (time.time() - start_time))

# New Data

# RFE same as RFECV, Chi2

# Feat imp.
feat_imp=['age', 'city', 'duration of asbestos exposure', 'keep side',
       'duration of symptoms', 'habit of cigarette', 'white blood',
       'cell count (WBC)', 'platelet count (PLT)', 'sedimentation',
       'blood lactic dehydrogenise (LDH)', 'alkaline phosphatise (ALP)',
       'total protein', 'albumin', 'glucose', 'pleural lactic dehydrogenise',
       'pleural albumin', 'pleural glucose', 'C-reactive protein (CRP)']

# num_imp=['age', 'duration of asbestos exposure', 'duration of symptoms', 'white blood',
#          'cell count (WBC)', 'platelet count (PLT)', 'sedimentation',
#          'blood lactic dehydrogenise (LDH)', 'alkaline phosphatise (ALP)',
#          'total protein', 'albumin', 'glucose', 'pleural lactic dehydrogenise',
#          'pleural albumin', 'pleural glucose', 'C-reactive protein (CRP)']

X=X[feat_imp]

# scaler = MinMaxScaler()
# X[num_feat]=scaler.fit_transform(X[num_feat])

X_train,X_test,y_train,y_test= train_test_split(X,y, shuffle=True, test_size=0.2, random_state=42)

sc=StandardScaler()
X_train=sc.fit_transform(X_train)
X_test=sc.transform(X_test)
oversample = SMOTE(sampling_strategy='minority', random_state=42)
X_train, y_train= oversample.fit_resample(X_train, y_train)

# RFECV
X = mesdata[['age', 'duration of symptoms', 'platelet count (PLT)',
       'blood lactic dehydrogenise (LDH)', 'alkaline phosphatise (ALP)']]

# Permutation
X = mesdata[['gender', 'duration of symptoms', 'platelet count (PLT)',
       'C-reactive protein (CRP)', 'alkaline phosphatise (ALP)']]

# SHAP
X = mesdata[['gender', 'duration of symptoms', 'platelet count (PLT)',
       'cell count (WBC)', 'alkaline phosphatise (ALP)']]