# Transform
mesdata = pd.read_excel(r'C:\Users\tedch\Documents\Thesis\Code\mesdata.xls')
mesdata = mesdata.rename(columns={'class of diagnosis': 'diagnosis'})
mesdata.diagnosis.replace({1:0,2:1},inplace=True)
y=mesdata.diagnosis
# Drop features
X=mesdata.drop(['diagnosis', 'diagnosis method', 'pleural protein', 'type of MM', 'dead or not'],axis=1)

# Standard Scaling Before
# sc=StandardScaler()
# Xfit=sc.fit(X)
# X=sc.fit_transform(X)
# X=pd.DataFrame(X)

# Minmaxscaler
# num_feat=['age','duration of asbestos exposure', 'duration of symptoms', 'white blood', 'cell count (WBC)',
#           'platelet count (PLT)', 'sedimentation', 'blood lactic dehydrogenise (LDH)', 'alkaline phosphatise (ALP)',
#           'total protein', 'albumin', 'glucose', 'pleural lactic dehydrogenise', 'pleural albumin',
#           'pleural glucose', 'C-reactive protein (CRP)']
# scaler = MinMaxScaler()
# X=scaler.fit(X[num_feat])
# X[num_feat]=scaler.fit_transform(X)

# Log transform
transform=['duration of symptoms', 'platelet count (PLT)', 'alkaline phosphatise (ALP)', 'glucose',
           'pleural lactic dehydrogenise', 'cell count (WBC)', 'blood lactic dehydrogenise (LDH)']
X[transform]=X[transform].apply(np.log)

# Split
feature_names = list(X.columns)
X_train,X_test,y_train,y_test= train_test_split(X,y, shuffle=True, test_size=0.2, random_state=42)

# Standard Scaling
sc=StandardScaler()
X_train=sc.fit_transform(X_train)
X_test=sc.transform(X_test)
oversample = SMOTE(random_state=42)
X_train, y_train= oversample.fit_resample(X_train, y_train)

X_train= pd.DataFrame(X_train, columns = X.columns)

scoring = {'accuracy' : make_scorer(accuracy_score),
           'precision' : make_scorer(precision_score),
           'recall' : make_scorer(recall_score),
           'f1_score' : make_scorer(f1_score)
           # ,'roc_auc' : make_scorer(roc_auc_score)
           }

# Get metrics function
def get_scores(scores):
    scoredict={
        'accuracy' : np.mean(scores.get('test_accuracy'))*100,
        'recall' : np.mean(scores.get('test_recall'))*100,
        'precision' : np.mean(scores.get('test_precision'))*100,
        'f1-score' : np.mean(scores.get('test_f1_score'))*100
        #, 'roc_auc' : np.mean(scores.get('test_roc_auc'))*100
    }
    print(scoredict)


